﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml.Linq;
using Infragistics.Controls.Editors;
using Infragistics.Documents.RichText;
using Infragistics.Documents.RichText.Rtf;
using Microsoft.Office.Interop.Outlook;

namespace RtfTest
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : System.Windows.Window
	{
		//private Font m_Font;
		private _Application m_OutlookGuarded;
		private _Application m_OutlookUnguarded;
		private MailItem m_MailItem;

		public MainWindow()
		{
			InitializeComponent();
		}

		private void XamRichTextEditor_Loaded(object sender, System.Windows.RoutedEventArgs e)
		{
			XamRichTextEditor rte = sender as XamRichTextEditor;

			CharacterSettings cs = new CharacterSettings();
			cs.FontSize = new Extent(9, ExtentUnitType.Points);
			cs.Bold = false;
			cs.Italics = false;

			FontSettings fs = new FontSettings();
			fs.Ascii = "Arial";

			cs.FontSettings = fs;

			string error = "ERROR";
			rte.Document.ApplyCharacterSettings(DocumentSpan.All, cs, out error);

			RtfBoxBody.Selection.Text = "Dies ä ist ö ein ü Test";
		}

		public string GetRtfText()
		{
			string strRtfCurrBody = string.Empty;
			using (MemoryStream ms = new MemoryStream())
			{
				RtfBoxBody.Document.Save(RtfSerializationProvider.Instance, ms);
				ms.Seek(0, SeekOrigin.Begin);
				using (StreamReader sr = new StreamReader(ms))
				{
					strRtfCurrBody = sr.ReadToEnd();
				}
			}

			return strRtfCurrBody;
		}

		private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			RtfControl.Selection.Text = GetRtfText();
		}

		private void Button_Click_1(object sender, System.Windows.RoutedEventArgs e)
		{
			m_MailItem = GetOutlookInstance(true)?.CreateItem(OlItemType.olMailItem);
			m_MailItem.Display();
			SetBody(GetRtfText());
		}


		public _Application GetOutlookInstance(bool canStartOutlook)
		{
			if (m_OutlookUnguarded == null)
			{
				GetOutlookApplication(canStartOutlook);
			}

			_Application outlook = null;
			if (m_OutlookUnguarded != null)
			{
				outlook = m_OutlookUnguarded;
			}
			else if (m_OutlookGuarded != null)
			{
				outlook = m_OutlookGuarded;
			}

			if (outlook == null)
				return null;

			return outlook;
		}

		protected void GetOutlookApplication(bool canStartOutlook)
		{
			try
			{
				m_OutlookGuarded = (Application)Marshal.GetActiveObject("Outlook.Application");
			}
			catch (COMException)
			{
				if (!canStartOutlook)
				{
					return;
				}
			}

			if (m_OutlookGuarded == null)
			{
				m_OutlookGuarded = new Application();
			}
		}

		public void SetBody(string body)
		{
			var byteBody = Encoding.ASCII.GetBytes(body);
			m_MailItem.BodyFormat = OlBodyFormat.olFormatRichText;
			var bodyFormat = m_MailItem.BodyFormat;
			m_MailItem.RTFBody = byteBody;
			m_MailItem.BodyFormat = OlBodyFormat.olFormatHTML;
			m_MailItem.HTMLBody = m_MailItem.HTMLBody;
		}
	}
}
